//
//  IAPManager.h
//  IAPDemo
//
//  Created by Charles.Yao on 2016/10/31.
//  Copyright © 2016年 com.pico. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "PayVerifyModel.h"

#import <StoreKit/StoreKit.h>

typedef NS_ENUM(NSInteger, IAPFiledCode) {
    /**
     *  苹果返回错误信息
     */
    IAP_FILEDCOED_APPLECODE = 0,
    
    /**
     *  用户禁止应用内付费购买
     */
    IAP_FILEDCOED_NORIGHT = 1,
    
    /**
     *  商品为空
     */
    IAP_FILEDCOED_EMPTYGOODS = 2,
    /**
     *  无法获取产品信息，请重试
     */
    IAP_FILEDCOED_CANNOTGETINFORMATION = 3,
    /**
     *  购买失败，请重试
     */
    IAP_FILEDCOED_BUYFILED = 4,
    /**
     *  用户取消交易
     */
    IAP_FILEDCOED_USERCANCEL = 5,
    /**
     *  验证失败
     */
    IAP_FILEDCODE_VERIFY = 6,
    /**
     *  恢复购买失败
     */
    IAP_FILEDCODE_RESTORE_FAILED = 7
};


@protocol IApRequestResultsDelegate <NSObject>

- (void)filedWithErrorCode:(NSInteger)errorCode appleErrorCode:(NSInteger)appleErrorCode domain:(NSString*)domain transId:(NSString*)tid error:(NSString *)error qonversionError:(NSString*)qError errFuncName:(NSString*)errFuncName errFileName:(NSString*)errFileName errLineNum:(int)errLineNum; //失败

@optional
/** 校验成功后的回调 */
-(void)verifySuccessWithModel:(PayVerifyModel *)model transId:(NSString*)tid;

@end


@interface IAPManager : NSObject

singleton_interface(IAPManager)

@property (nonatomic, weak)id<IApRequestResultsDelegate>delegate;

/**
 启动工具
 */
- (void)startManager;

/**
 结束工具
 */
- (void)stopManager;

/** 产品Id */
@property (nonatomic,copy) NSString * productId;
/** 支付页面的触发界面 */
@property (nonatomic,copy) NSString * origin;
/** 成功回调 */
//@property (nonatomic,copy) void(^verifySuccessBlock)(PayVerifyModel *model);


/**
 请求商品列表
 */
- (void)requestProductWithId:(NSString *)productId origin:(NSString *)origin;

/// 检查会员状态
- (void)checkPermissons;

- (void)restoreWithFinish:(void (^)(bool,NSError*))finish;
@end
